
requireNamespace("shiny", quietly = TRUE)
requireNamespace("gtools", quietly = TRUE)

library("gtools", quietly = TRUE)
fix_dist <- c(700,0)
dist_planes  <- seq(140, 1500, 10)
m_xs <- seq(-27, 27, length.out = 10)
m_ys <- seq(21, -21, -6)
c_xs <- seq(-57, 57, 6)  # x coordinates at which binocular visual field is computed (degrees)
###make fake data from the 12 archetypes
at_num <- 13 ## at stands for archetypes
at_id <- sapply(1:at_num, function(i) 1:at_num + (i)*100)
at_id <- as.vector(at_id)

at_gender <- factor(rep('female', length(at_id)), levels=c('female','male'))
# at_theta_left <- sapply(at_gender, fixdist = fix_dist, caltheta, gender="female", eye = "left")
# at_theta_rght <- sapply(at_gender, fixdist = fix_dist, caltheta, gender="female", eye = "right")


at_rght_1 <- matrix(c(
  NA, NA, NA, 30, 30, 30, 30, NA, NA, NA,
  NA, NA, 30, 30, 30, 30, 30, 30, NA, NA,
  NA, 30, 30, 30, 30, 30, 30, 30, 30, NA,
  30, 30, 30, 30, 30, 30, 30, 30, 30, NA,
  30, 30, 30, 30, 30, 30, 30,  0, 30, NA,
  NA, 30, 30, 30, 30, 30, 30, 30, 30, NA,
  NA, NA, 30, 30, 30, 30, 30, 30, NA, NA,
  NA, NA, NA, 30, 30, 30, 30, NA, NA, NA
), ncol=10, byrow=TRUE)

at_rght_2 <- matrix(c(
  NA, NA, NA,  0,  0,  0,  0, NA, NA, NA,
  NA, NA,  0,  0,  0,  0,  0,  0, NA, NA,
  NA,  0,  0,  0,  0,  0,  0,  0,  0, NA,
  30, 30, 30, 30, 30,  0,  0,  0,  0, NA,
  30, 30, 30, 30, 30, 30, 30,  0, 30, NA,
  NA, 30, 30, 30, 30, 30, 30, 30, 30, NA,
  NA, NA, 30, 30, 30, 30, 30, 30, NA, NA,
  NA, NA, NA, 30, 30, 30, 30, NA, NA, NA
), ncol=10, byrow=TRUE)

at_rght_3 <- matrix(c(
  NA, NA, NA,  0,  0, 30, 30, NA, NA, NA,
  NA, NA,  0,  0,  0,  0, 30, 30, NA, NA,
  NA,  0,  0,  0,  0,  0, 30, 30, 30, NA,
   0,  0,  0,  0,  0, 30, 30, 30, 30, NA,
  30, 30, 30, 30, 30, 30, 30,  0, 30, NA,
  NA, 30, 30, 30, 30, 30, 30, 30, 30, NA,
  NA, NA, 30, 30, 30, 30, 30, 30, NA, NA,
  NA, NA, NA, 30, 30, 30, 30, NA, NA, NA
), ncol=10, byrow=TRUE)

at_rght_4 <- matrix(c(
  NA, NA, NA, 30, 30, 30, 30, NA, NA, NA,
  NA, NA, 30, 30, 30, 30, 30, 30, NA, NA,
  NA, 30, 30, 30, 30, 30, 30, 30,  0, NA,
  30, 30, 30, 30, 30, 30, 30, 30,  0, NA,
  30, 30, 30, 30, 30, 30, 30,  0,  0, NA,
  NA, 30, 30, 30, 30, 30, 30, 30,  0, NA,
  NA, NA, 30, 30, 30, 30, 30, 30, NA, NA,
  NA, NA, NA, 30, 30, 30, 30, NA, NA, NA
), ncol=10, byrow=TRUE)

at_rght_5 <- matrix(c(
  NA, NA, NA, 30, 30, 30, 30, NA, NA, NA,
  NA, NA, 30, 30, 30, 30, 30, 30, NA, NA,
  NA, 30, 30, 30, 30, 30, 30, 30, 30, NA,
  30, 30, 30, 30, 30, 30, 30, 30, 30, NA,
   0,  0,  0,  0, 30, 30, 30,  0, 30, NA,
  NA,  0,  0,  0, 30, 30, 30, 30, 30, NA,
  NA, NA,  0, 30, 30, 30, 30, 30, NA, NA,
  NA, NA, NA, 30, 30, 30, 30, NA, NA, NA
), ncol=10, byrow=TRUE)

at_rght_6 <- matrix(c(
  NA, NA, NA,  0,  0,  0,  0, NA, NA, NA,
  NA, NA,  0,  0,  0,  0,  0,  0, NA, NA,
  NA,  0,  0,  0,  0,  0,  0,  0,  0, NA,
   0,  0,  0,  0,  0,  0,  0,  0,  0, NA,
   0,  0,  0,  0,  0, 30, 30,  0,  0, NA,
  NA,  0,  0,  0,  0,  0,  0,  0,  0, NA,
  NA, NA,  0,  0,  0,  0,  0,  0, NA, NA,
  NA, NA, NA,  0,  0,  0,  0, NA, NA, NA
), ncol=10, byrow=TRUE)

# at_rght_7 <- matrix(c(
#   NA, NA, NA, 30, 30, 30, 30, NA, NA, NA,
#   NA, NA, 30, 30, 30, 30, 30, 30, NA, NA,
#   NA,  0, 30, 30, 30,  0, 30, 30, 30, NA,
#   0,  0, 30,  0,  0,  0,  0, 30, 30, NA,
#   0,  0,  0,  0,  0,  0,  0,  0, 30, NA,
#   NA,  0,  0,  0,  0,  0,  0, 30, 30, NA,
#   NA, NA,  0, 30,  0,  0, 30, 30, NA, NA,
#   NA, NA, NA, 30, 30, 30, 30, NA, NA, NA
# ), ncol=10, byrow=TRUE)

at_rght_7 <- matrix(c(
  NA, NA, NA,  0,  0,  0,  0, NA, NA, NA,
  NA, NA,  0,  0,  0,  0,  0,  0, NA, NA,
  NA,  0,  0,  0,  0,  0,  0,  0,  0, NA,
  0,  0,  0,  0,  0,  0,  0,  0,  0, NA,
  30, 30, 30, 30, 30, 30, 30,  0,  0, NA,
  NA, 30, 30, 30, 30, 30, 30, 30, 30, NA,
  NA, NA, 30, 30, 30, 30, 30, 30, NA, NA,
  NA, NA, NA, 30, 30, 30, 30, NA, NA, NA
), ncol=10, byrow=TRUE)

at_rght_8 <- matrix(c(
  NA, NA, NA, 30, 30, 30, 30, NA, NA, NA,
  NA, NA, 30, 30, 30, 30, 30, 30, NA, NA,
  NA, 30, 30, 30, 30, 30, 30, 30, 30, NA,
  30, 30, 30, 30, 30, 30, 30, 30, 30, NA,
  30, 30, 30, 30, 30, 30, 30,  0,  0, NA,
  NA, 30, 30, 30, 30,  0,  0,  0,  0, NA,
  NA, NA, 30, 30,  0,  0,  0,  0, NA, NA,
  NA, NA, NA,  0,  0,  0,  0, NA, NA, NA
), ncol=10, byrow=TRUE)

at_rght_9 <- matrix(c(
  NA, NA, NA, 30, 30, 30, 30, NA, NA, NA,
  NA, NA, 30, 30, 30, 30, 30, 30, NA, NA,
  NA, 30, 30, 30, 30, 30, 30, 30, 30, NA,
  30, 30, 30, 30, 30, 30, 30, 30, 30, NA,
   0,  0,  0,  0, 30, 30, 30,  0, 30, NA,
  NA,  0,  0,  0,  0,  0,  0,  0, 30, NA,
  NA, NA,  0,  0,  0,  0,  0,  0, NA, NA,
  NA, NA, NA,  0,  0,  0,  0, NA, NA, NA
), ncol=10, byrow=TRUE)

at_rght_10 <- matrix(c(
  NA, NA, NA, 30, 30, 30, 30, NA, NA, NA,
  NA, NA, 30, 30, 30, 30, 30, 30, NA, NA,
  NA, 30, 30, 30, 30, 30, 30, 30, 30, NA,
  30, 30, 30, 30, 30, 30, 30, 30, 30, NA,
  0,  0,  0,  0,  0, 30,  0,  0,  0, NA,
  NA,  0,  0,  0,  0,  0,  0,  0,  0, NA,
  NA, NA,  0,  0,  0,  0,  0,  0, NA, NA,
  NA, NA, NA,  0,  0,  0,  0, NA, NA, NA
), ncol=10, byrow=TRUE)

at_rght_11 <- matrix(c(
  NA, NA, NA, 30, 30, 30, 30, NA, NA, NA,
  NA, NA, 30, 30, 30, 30, 30, 30, NA, NA,
  NA,  0, 30, 30,  0,  0,  0, 30, 30, NA,
  0,  0,  0,  0,  0,  0,  0,  0, 30, NA,
  30, 30, 30, 30, 30, 30, 30,  0, 30, NA,
  NA, 30, 30, 30, 30, 30, 30, 30, 30, NA,
  NA, NA, 30, 30, 30, 30, 30, 30, NA, NA,
  NA, NA, NA, 30, 30, 30, 30, NA, NA, NA
), ncol=10, byrow=TRUE)

at_rght_12 <- matrix(c(
  NA, NA, NA, 30, 30, 30, 30, NA, NA, NA,
  NA, NA, 30, 30, 30, 30, 30, 30, NA, NA,
  NA, 30, 30, 30, 30, 30, 30, 30, 30, NA,
  30, 30, 30, 30, 30, 30, 30, 30, 30, NA,
  0,  0,  0,  0,  0, 30, 30,  0, 30, NA,
  NA,  0,  0,  0,  0,  0,  0, 30, 30, NA,
  NA, NA, 30, 30, 30, 30, 30, 30, NA, NA,
  NA, NA, NA, 30, 30, 30, 30, NA, NA, NA
), ncol=10, byrow=TRUE)


at_rght_13 <- matrix(c(
  NA, NA, NA, 30, 30, 30,  0, NA, NA, NA,
  NA, NA, 30, 30, 30, 30,  0,  0, NA, NA,
  NA, 30, 30, 30, 30, 30,  0,  0,  0, NA,
  30, 30, 30, 30, 30, 30,  0,  0,  0, NA,
  30, 30, 30, 30, 30, 30,  0,  0,  0, NA,
  NA, 30, 30, 30, 30, 30,  0,  0,  0, NA,
  NA, NA, 30, 30, 30, 30,  0,  0, NA, NA,
  NA, NA, NA, 30, 30, 30,  0, NA, NA, NA
), ncol=10, byrow=TRUE)

aa <- matrix(NA, nrow=8, ncol = 10)
at_rght_array <- replicate(at_num, aa)

for (ii in 1:at_num){
  at_rght_array[,,ii] <- get(paste('at_rght_', ii, sep=""))
}

at_left_array <- at_rght_array[, 10:1, ]

conditions <- permutations(at_num, 2, v=1:at_num, repeats.allowed=T)

at_rght_vf_array <- at_rght_array[, , conditions[,1]]
at_left_vf_array <- at_left_array[, , conditions[,2]]


vf_height = 250
vf_width = "80%"
c_vf_height = 250
c_vf_width = "100%"
###start shiny
ui <- navbarPage(
      title ="Binocular vision simulated using glaucoma archetypes",

      tabPanel(title = "Binocular vision in 3D",
               fluidPage(

                 fluidRow(
                   fluidRow(
                     column(6, h1("Binocular vision in 3D", align = "center")),
                     column(3, selectInput(inputId = "id_t1", label="Combination ID", choices = at_id, size=3, selectize = FALSE)),
                     column(3, actionButton("update_t1", "Select")))
                 ),

                 fluidRow(
                   column(6,
                          fluidRow(
                            column(12, plotOutput("combined_ray", height=500))
                          ),
                          fluidRow(
                            column(12, sliderInput(inputId = "object_distance",
                                                   label = "Choose an object distance (cm)",
                                                   min = min(dist_planes), max = max(dist_planes), step = 10, value = 500, width = "100%"))
                          ),
                          fluidRow(
                            column(12, sliderInput(inputId = "fixation_t1",
                                                   label = "Choose a fixation distance (mm)",
                                                   min = min(dist_planes), max = max(dist_planes), step = 10, value = 600, width = "100%"))
                          )
                   ),
                   column(6,
                          fluidRow(
                            column(6, plotOutput("vf_left_t1",  height = vf_height, width = vf_width)),
                            column(6, plotOutput("vf_rght_t1",  height = vf_height, width = vf_width))
                          ),
                          fluidRow(
                            column(12, plotOutput("c_vf_fixation_t1", height = 300, width = c_vf_width))
                          ),
                          hr(),
                          fluidRow(
                            column(12, plotOutput("color_key", height = 100, width = c_vf_width))
                          )

                   )

                 )

               )## fluidPage
               ),##tabPanel

      tabPanel(
        title = "Binocular vision simulated using 12 archetypes",

        fluidPage(

          fluidRow(
            column(6, h1("Binocular vision at close, fixation and far planes", align = "center")),
            column(3, selectInput(inputId = "id_t2", label="Combination ID", choices = at_id, size = 3, selectize = FALSE)),
            column(3, actionButton("update_t2", "Select"))
          ),

          fluidRow(
            column(4, plotOutput("vf_left_t2", height = vf_height, width = vf_width),  offset = 2),
            column(4, plotOutput("vf_rght_t2", height = vf_height, width = vf_width))
          ),

          fluidRow(
            column(4, sliderInput(inputId = "object_close",
                                  label = "Choose a close object distance (mm)",
                                  min = min(dist_planes), max = 400, step = 10, value = 140, width = "100%")),
            column(4, sliderInput(inputId = "fixation_t2",
                                  label = "Choose a fixation distance (mm)",
                                  min = 410, max = 700, step = 10, value = 600, width = "100%")),
            column(4, sliderInput(inputId = "object_far",
                                  label = "Choose far object distance (mm)",
                                  min = 710, max = max(dist_planes), step = 10, value = 1000, width = "100%"))

          ),

          fluidRow(
            column(4, plotOutput("c_vf_close", height = c_vf_height, width = c_vf_width)),
            column(4, plotOutput("c_vf_fixation_t2", height = c_vf_height, width = c_vf_width)),
            column(4, plotOutput("c_vf_far", height = c_vf_height, width = c_vf_width))
          ) ##fluidRow
        ) ## fluidPage
      ) ##tabPanel

) ##navbarPage



server <- function(input, output, session){

  ###reactive data for tab 1
  fdd <- reactive({
    input$update_t1
    isolate({
      withProgress({
        setProgress(message = "Updating simulated data...")})
      index   <-  match(input$id_t1, at_id)
      rght_vf <-  at_rght_vf_array[, , index]
      left_vf <-  at_left_vf_array[, , index]
      gender  <-  at_gender[index]
      # pd      <-  at_pd[index]

    })
    list(index = index, left_vf = left_vf, rght_vf = rght_vf, gender = gender)
  })

  fddray <- reactive({
    # theta_left <- caltheta(fdd()$pd, c(input$fixation_t1, 0), eye = "left")
    # theta_rght <- caltheta(fdd()$pd, c(input$fixation_t1, 0), eye = "right")
    # c_vf       <- binovfcal(fdd()$left_vf, fdd()$rght_vf, fdd()$pd, theta_left, theta_rght, dist_planes)
    theta_left <- caltheta(c(input$fixation_t1, 0), gender=fdd()$gender, eye = "left")
    theta_rght <- caltheta(c(input$fixation_t1, 0), gender=fdd()$gender, eye = "right")
    c_vf       <- binovfcal(fdd()$left_vf, fdd()$rght_vf, theta_left, theta_rght, dist_planes, gender=fdd()$gender)
    list(theta_left = theta_left, theta_rght = theta_rght, c_vf = c_vf)
  })

  fdd_t2 <- reactive({
    input$update_t2
    isolate({
      withProgress({
        setProgress(message = "Updating simulated data...")})
      index      <-  match(input$id_t2, at_id)
      rght_vf    <- at_rght_vf_array[, , index]
      left_vf    <- at_left_vf_array[, , index]
      gender     <-  at_gender[index]
      # pd      <- at_pd[index]
    })
    list(index = index, left_vf = left_vf, rght_vf = rght_vf, gender = gender)
  })

  fdd_c_t2 <- reactive({
     # theta_left <- caltheta(fdd_t2()$pd, c(input$fixation_t2, 0), eye = "left")
     # theta_rght <- caltheta(fdd_t2()$pd, c(input$fixation_t2, 0), eye = "right")
     # c_vf       <- binovfcal(fdd_t2()$left_vf, fdd_t2()$rght_vf, fdd_t2()$pd, theta_left, theta_rght, dist_planes)
     theta_left <- caltheta(c(input$fixation_t2, 0), gender=fdd_t2()$gender, eye = "left")
     theta_rght <- caltheta(c(input$fixation_t2, 0), gender=fdd_t2()$gender, eye = "right")
     c_vf       <- binovfcal(fdd_t2()$left_vf, fdd_t2()$rght_vf, theta_left, theta_rght, dist_planes, gender=fdd_t2()$gender)
  })


  ### tab 1
  output$combined_ray <- renderPlot({
    plotvfray (fdd()$left_vf, fdd()$rght_vf, fddray()$theta_left, fddray()$theta_rght, c(input$fixation_t1, 0), input$object_distance)
  }, height = 500)


  output$vf_left_t1 <- renderPlot({
    plotvf(m_xs, fdd()$left_vf, "Left Monocular")
  }, height = 250)

  output$vf_rght_t1 <- renderPlot({
    plotvf(m_xs, fdd()$rght_vf, "Right Monocular")
  }, height = 250)

  output$c_vf_fixation_t1 <- renderPlot({
    plotvf(c_xs, fddray()$c_vf[, , as.character(input$object_distance)], paste0("Binocular fix = ", input$fixation_t1, "mm Object = ", input$object_distance, "mm"))
  }, height = 300)

  output$color_key <- renderPlot({colorkey()}, height = 100)

  ### tab 2
  output$vf_left_t2 <- renderPlot({
    plotvf(m_xs, fdd_t2()$left_vf, "Left Monocular")
  }, height = vf_height)

  output$vf_rght_t2 <- renderPlot({
    plotvf(m_xs, fdd_t2()$rght_vf, "Right Monocular")
  }, height = vf_height)


  output$c_vf_close <- renderPlot({
    plotvf(c_xs, fdd_c_t2()[, , as.character(input$object_close)], paste0("close distance = ", input$object_close, "mm"))
  }, height = c_vf_height)

  output$c_vf_fixation_t2 <- renderPlot({
    plotvf(c_xs, fdd_c_t2()[, , as.character(input$fixation_t2)], paste0("fixation distance = ", input$fixation_t2, "mm"))
  }, height = c_vf_height)

  output$c_vf_far <- renderPlot({
    plotvf(c_xs, fdd_c_t2()[, , as.character(input$object_far)], paste0("far distance = ", input$object_far, "mm"))
  }, height = c_vf_height)
}

shinyApp(ui=ui, server = server)

